package com.dgtis.data.domain;

import com.dgtis.common.core.annotation.Excel;

/**
 * @author koucx
 * @version 1.0
 * @descption: TODO
 * @company 神州数码通用软件（洛阳）有限公司
 * @copyright (c) 2019 LuoYang DGT Co'Ltd Inc. All rights reserved.
 * @date 2021-03-03
 * @since JDK1.8
 */
public class Customer {

    /** 核心客户号 */
    @Excel(name = "核心客户号")
    private String scustId;

    /** 客户号 */
    @Excel(name = "客户号")
    private String custId;

    /** 姓名 */
    @Excel(name = "姓名")
    private String name;

    /** 证件类型 */
    @Excel(name = "证件类型")
    private String idType;


    /** 证件号码 */
    @Excel(name = "证件号码")
    private String idCard;

    /** 性别 */
    @Excel(name = "性别")
    private String sex;

    /** 出生日期 */
    @Excel(name = "出生日期")
    private String birthDay;


    /** 年龄 */
    @Excel(name = "年龄")
    private int age;

    /** 客户等级 */
    @Excel(name = "客户等级")
    private String custClass;

    /** 客户类型 */
    @Excel(name = "客户类型")
    private String custType;

    /** 省份 */
    @Excel(name = "省份")
    private String province;

    /** 学历 */
    @Excel(name = "学历")
    private String education;

    /** 是否有效客户 */
    @Excel(name = "是否有效客户")
    private String vaild;

    /** 业绩归属 */
    @Excel(name = "业绩归属")
    private String policyBelong;


    /** 年收入 */
    @Excel(name = "年收入")
    private String pIncome;

    /** 保单件数 */
    @Excel(name = "保单件数")
    private String num;

    public String getScustId() {
        return scustId;
    }

    public void setScustId(String scustId) {
        this.scustId = scustId;
    }

    public String getCustId() {
        return custId;
    }

    public void setCustId(String custId) {
        this.custId = custId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getIdType() {
        return idType;
    }

    public void setIdType(String idType) {
        this.idType = idType;
    }

    public String getIdCard() {
        return idCard;
    }

    public void setIdCard(String idCard) {
        this.idCard = idCard;
    }

    public String getSex() {
        return sex;
    }

    public void setSex(String sex) {
        this.sex = sex;
    }

    public String getBirthDay() {
        return birthDay;
    }

    public void setBirthDay(String birthDay) {
        this.birthDay = birthDay;
    }

    public int getAge() {
        return age;
    }

    public void setAge(int age) {
        this.age = age;
    }

    public String getCustClass() {
        return custClass;
    }

    public void setCustClass(String custClass) {
        this.custClass = custClass;
    }

    public String getCustType() {
        return custType;
    }

    public void setCustType(String custType) {
        this.custType = custType;
    }

    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    public String getEducation() {
        return education;
    }

    public void setEducation(String education) {
        this.education = education;
    }

    public String getVaild() {
        return vaild;
    }

    public void setVaild(String vaild) {
        this.vaild = vaild;
    }

    public String getPolicyBelong() {
        return policyBelong;
    }

    public void setPolicyBelong(String policyBelong) {
        this.policyBelong = policyBelong;
    }

    public String getpIncome() {
        return pIncome;
    }

    public void setpIncome(String pIncome) {
        this.pIncome = pIncome;
    }

    public String getNum() {
        return num;
    }

    public void setNum(String num) {
        this.num = num;
    }
}
