CREATE OR REPLACE PROCEDURE shanglifeecif.init_insurancearrangement() -- 洢
IS    
BEGIN
	--policy_information ±
	shanglifeecif.init_insurancearrangement_policy_information();
	--ִ
	shanglifeecif.update_risk_categories();
END;



/

CREATE OR REPLACE PROCEDURE shanglifeecif.init_insurancearrangement_policy_information() -- 洢
IS    
BEGIN

INSERT INTO shanglifeecif.insurancearrangement(
  iaid ,--'ID', 
  policyno ,-- 'յ INSURANCEINFO.CONTNO', 
  pindate ,-- ' POLICY_INFORMATION.CVALIDATE', 
  pmdate ,-- 'ձ POLICY_INFORMATION.ENDDATE', 
  norenewal ,-- ' POLICY_INFORMATION.PAYCOUNT', 
  payment ,-- 'ɷѷʽ POLICY_INFORMATION.PAYINTV', 
  applicantscustid ,-- 'Ͷ οͻţҵindividualid', 
  appname ,-- 'Ͷ POLICY_INFORMATION.NAME', 
  appcertid ,-- 'Ͷ֤ POLICY_INFORMATION.IDNO', 
  insuredscustid ,-- ' οͻ', 
  insname ,-- ' POLICY_INFORMATION.INSUREDNAME', 
  inscertid ,-- '֤ POLICY_INFORMATION.INSUREDIDNO', 
  productid ,-- 'ִ POLICY_INFORMATION.RISKCODE', 
  productname,--
  policybelong ,-- 'ҵ POLICY_INFORMATION.SALECOM',  
  payendyear ,-- 'ɷ POLICY_INFORMATION.PAYENDYEAR', 
  policystate,--״̬
  prem,--
  Risk,--
  NPDate,--´νɷ
  PADate,--Ͷ
  pisdate,--ǩ
  AgentOrg,--
  schannel,--
   POService,--ȫ־
  PWComp,--бֹ˾
  agrmntage ,--
  created_by ,-- '', 
  created_time -- 'ʱ' 

) 
SELECT 
	row_number()over(),
	trim(CONTNO) as CONTNO,--policyno ,-- 'յ INSURANCEINFO.CONTNO', 
	trim(CVALIDATE) as CVALIDATE,--pindate ,-- ' POLICY_INFORMATION.CVALIDATE', 
	trim(ENDDATE) as ENDDATE,--pmdate ,-- 'ձ POLICY_INFORMATION.ENDDATE', 
	PAYCOUNT,--norenewal ,-- ' POLICY_INFORMATION.PAYCOUNT', 
	trim(PAYINTV) as PAYINTV,--payment ,-- 'ɷѷʽ POLICY_INFORMATION.PAYINTV', 
	trim(CUSTOMERNO) as CUSTOMERNO,--applicantid ,-- 'Ͷ POLICY_INFORMATION.CUSTOMERNOindividualοͻţҵindividualid', 
	trim(NAME) as NAME,--appname ,-- 'Ͷ POLICY_INFORMATION.NAME', 
	trim(IDNO) as IDNO,--appcertid ,-- 'Ͷ֤ POLICY_INFORMATION.IDNO', 
	trim(insuredno) as insuredno,--insuredid ,-- ' insuredno', 
	trim(INSUREDNAME) as INSUREDNAME,--insname ,-- ' POLICY_INFORMATION.INSUREDNAME', 
	trim(INSUREDIDNO) as INSUREDIDNO,--inscertid ,-- '֤ POLICY_INFORMATION.INSUREDIDNO', 
	trim(RISKCODE) as RISKCODE,--productid ,-- 'ִ POLICY_INFORMATION.RISKCODE', 
	trim(RISKNAME) as RISKNAME, --productname 
	trim(SALECOM) as SALECOM,--policybelong ,-- 'ҵ POLICY_INFORMATION.SALECOM', 
	PAYENDYEAR,--payendyear ,-- 'ɷ POLICY_INFORMATION.PAYENDYEAR', 
	trim(APPFLAG) as APPFLAG, --״̬
	prem,--
	AMNT,--
	trim(PAYTODATE) as PAYTODATE,--´νɷ
	trim(CUSTOMGETPOLDATE) as CUSTOMGETPOLDATE,--Ͷ
	trim(SIGNDATE) as SIGNDATE,--ǩ
	trim(AGENTCOM) as AGENTCOM,--
	trim(SALECHNL) as SALECHNL,--
	trim(PRESERVATIONFLAG) as PRESERVATIONFLAG,--ȫ־
	"ϺϺֹ˾",
	case
		when security ='' then 42720
		when security = '100' then 36500
		when security = '80' then 29200
		when security = '70' then 25550
		when security = '70' then 25550
		when security = '65' then 23725
		when security = '60' then 21900
		when security = '30' then 10950
		when security = '20' then 7300
		when security = '10' then 3650
		when security = '6' then 2190
		when security = '5' then 1825
		when security = '1' then 365
		when security = '180' then 180
		when security = '6' then 180
		when security = '90' then 90
		when security = '3' then 90
		when security = '1' then 30
		when security = '30' then 30
		when security = '15' then 15
		when security = '7' then 7
	end,
	'admin',
	sysdate() 
	FROM shanghailifeecif.policy_information 
	
	--INSURANCEINFO еϢ

	UPDATE shanglifeecif.insurancearrangement a SET (
		pano ,-- 'Ͷ INSURANCEINFO.PRTNO',  
		--pisdate ,-- 'ǩ INSURANCEINFO.SIGNDATE', 
		--padate ,-- 'Ͷ INSURANCEINFO.POLAPPLYDATE', 
		--policystate ,--INSURANCEINFO,appflag
		--prem ,-- 'ܱ INSURANCEINFO.PREM', 
		--productname ,-- '	 INSURANCEINFO.RISKNAME'
		agentchannel -- ' INSURANCEINFO.SELLTYPE', 
	) = (
		select
			trim(b.PRTNO) as PRTNO,--pano ,-- 'Ͷ INSURANCEINFO.PRTNO',  
			--SIGNDATE,--pisdate ,-- 'ǩ INSURANCEINFO.SIGNDATE', 
			--POLAPPLYDATE,--padate ,-- 'Ͷ INSURANCEINFO.POLAPPLYDATE', 
			--appflag,--policystate ,--INSURANCEINFO,appflag
			--PREM,--prem ,-- 'ܱ INSURANCEINFO.PREM', 
			--RISKNAME,--productname ,-- '	 INSURANCEINFO.RISKNAME'
			trim(b.SELLTYPE) as SELLTYPE--agentchannel ,-- ' INSURANCEINFO.SELLTYPE', 
		from shanghailifeecif.INSURANCEINFO b
		where b.contno  = a.policyno
	) WHERE 1=1 ;

END;
/
CREATE OR REPLACE PROCEDURE shanglifeecif.update_risk_categories() -- 洢
IS    
BEGIN
--ִ
	UPDATE shanglifeecif.insurancearrangement a SET (
		risk_categories,
		risk_categories_name
	) = (
		
		select
				b.kindcode,
				(CASE b.kindcode 
					WHEN 'A' THEN '˺' 
					WHEN 'U' THEN 'ܱ' 
					WHEN 'R' THEN '' 
					WHEN 'S' THEN 'ؼ' 
					WHEN 'L' THEN 'ٱ' 
					WHEN 'H' THEN '' 
				END) AS kindname
			from lmriskapp b WHERE a.productid = b.riskcode
	
	) WHERE 1=1;

END;

